-----------------------------------
-- Abilities Initialization      --
-----------------------------------

function sh.set.power_spawn(p)
	local id, n, hp, ap, sp, max, img
	hp = sh_player_hp ; ap = sh_player_ap ; sp = sh_player_sp
	for id, n in pairs(pl.item[p]) do
		if (sh_item.health[id]) then hp = hp + sh_item.health[id] end
		if (sh_item.armor[id]) then ap = ap + sh_item.armor[id] end
		if (sh_item.speed[id]) then sp = sp + sh_item.speed[id] end
		if (sh_item.item[id]) then  sh.parse(5,p,sh_item.item[id]) end
		if (sh_item.hook_spawn[id]) then
			p_id, item_id = p, id
			sh.expand(sh_item.hook_spawn[id])
		end
	end
	for id, n in pairs(pl.hero[p]) do
		up = sh.up(p, id)
		if (hero.health[id]) then hp = hp + hero.health[id][sh.maxup([[health]], id, up)] end
		if (hero.armor[id]) then ap = ap + hero.armor[id][sh.maxup([[armor]], id, up)] end
		if (hero.speed[id]) then sp = sp + hero.speed[id][sh.maxup([[speed]], id, up)] end
		if (hero.spwn_info[id]) then sh.sv_msg2(p,hero.spwn_info[id][sh.maxup([[spwn_info]], id, up)]) end
		if (hero.img_oval[id]) then
			max = sh.maxup([[img_oval]], id, up)
			sh.timer_cnt = sh.timer_cnt + 1 ; sh.timer[sh.timer_cnt] = {p,hero.img_oval[id][max][2],hero.img_oval[id][max][3],hero.img_oval[id][max][4],hero.img_oval[id][max][5],hero.img_oval[id][max][1]}
		end
		if (hero.throw_grenade[id]) then pl.throw_grenade[p][id] = true end
		if (hero.throw_weapon[id]) then pl.throw_weapon[p][id] = true end
		if (hero.sh_item[id]) then
			local iid = hero.sh_item[id][sh.maxup([[sh_item]], id, up)]
			if sh_item.name[iid] then
				if (not pl.item[p][iid] or pl.item[p][iid] < 0) then pl.item[p][iid] = 1 end
			else
				sh.msg( 2, [[Error: Item Doesn't Exist!]])
			end
		end
		if (hero.hook_spawn[id]) then
			p_id, hero_id, hero_lvl = p, id, n
			sh.expand(hero.hook_spawn[id][sh.maxup([[hook_spawn]], id, up)])
		end
	end
	sh.parse(3,p,hp)
	if (sp ~= 0) then sh.parse(6,p,sp) end
	if (ap > 0 and ap < 200) then sh.parse(4,p,ap) elseif (ap > 200) then sh.parse(4,p,200) end 
	pl.t_speed[p] = sp
	for id, n in pairs(pl.hero[p]) do
		if (hero.item[id]) then sh.parse(5,p,hero.item[id][sh.maxup([[item]], id, up)]) end
	end
end

function sh.set.power_noreload(p)
	local w, id, n , up, max = player(p,[[weapontype]])
	for id, n in pairs(pl.hero[p]) do
		up = pl.hero[p][id] or 0
		if (hero.noreload[id]) then
			max = sh.maxup([[noreload]], id, up)
			if (hero.noreload[id][max] == w) then
				sh.parse(5,p,w)
			elseif (hero.noreload[id][max] == 0) then
				sh.parse(5,p,w)
				break
			end
		end
		if (hero.hook_reload[id]) then
			p_id, hero_id, wpn_id, hero_lvl = p, id, w, n
			sh.expand(hero.hook_reload[id][sh.maxup([[hook_reload]], id, up)])
		end
	end
end

function sh.set.power_select(p,id,up)
	if (hero.sel_info[id]) then msg2(p,hero.sel_info[id][sh.maxup([[sel_info]], id, up)]) end
	if (hero.img_oval[id]) then
		max = sh.maxup([[img_oval]], id, up)
		sh.timer_cnt = sh.timer_cnt + 1 ; sh.timer[sh.timer_cnt] = {p,hero.img_oval[id][max][2],hero.img_oval[id][max][3],hero.img_oval[id][max][4],hero.img_oval[id][max][5],hero.img_oval[id][max][1]}
	end
	if (hero.hook_select[id]) then
		p_id, hero_id, hero_lvl = p, id, up
		sh.expand(hero.hook_select[id][sh.maxup([[hook_select]], id, up)])
	end
end

function sh.set.power_second()
	local m, n, p, id, up, max, hp, mn, ap, p_, m_ , sp
	for m, p in pairs(player(0,[[table]])) do
		if (pl.speed[p] > 0) then
			if (pl.speed[p] == 1) then sh.parse(6,p,pl.t_speed[p]) end
			pl.speed[p] = pl.speed[p] - 1
		end
		for id, n in pairs(pl.hero[p]) do
			if (player(p,[[health]]) > 0) then
				up = sh.up(p, id)
				if (hero.re_item[id]) then
					max = sh.maxup([[re_item]], id, up)
					pl.re_item[p][id] = pl.re_item[p][id] + 1
					if (pl.re_item[p][id] >= hero.re_item[id][max][2]) then
						pl.re_item[p][id] = 0 ; sh.parse(5,p,hero.re_item[id][max][1])
					end
				end
				if (hero.re_health[id]) then
					max = sh.maxup([[re_health]], id, up)
					pl.re_health[p][id] = pl.re_health[p][id] + 1 ; hp = player(p,[[health]])
					if (pl.re_health[p][id] >= hero.re_health[id][max][2]) then
						pl.re_health[p][id] = 0
						if (hp < player(p,[[maxhealth]])) then sh.parse(7,p,hp + hero.re_health[id][max][1]) end
					end
				end
				if (hero.re_armor[id]) then
					max = sh.maxup([[re_armor]], id, up)
					pl.re_armor[p][id] = pl.re_armor[p][id] + 1
					if (pl.re_armor[p][id] >= hero.re_armor[id][max][2]) then
						pl.re_armor[p][id] = 0
						ap = player(p,[[armor]]) + hero.re_armor[id][max][1]
						if (ap < 200) then sh.parse(4,p,ap) end
					end
				end
				if (hero.re_money[id]) then
					max = sh.maxup([[re_money]], id, up)
					pl.re_money[p][id] = pl.re_money[p][id] + 1 ; mn = player(p,[[money]])
					if (pl.re_money[p][id] >= hero.re_money[id][max][2]) then
						pl.re_money[p][id] = 0
						if (mn < 16000) then sh.parse(8,p,mn + hero.re_money[id][max][1]) end
					end
				end
				if (hero.nb_health[id]) then
					max = sh.maxup([[nb_health]], id, up)
					pl.nb_health[p][id] = pl.nb_health[p][id] + 1
					if (pl.nb_health[p][id] >= hero.nb_health[id][max][2]) then
						pl.nb_health[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (p_ ~= p and player(p_,[[health]]) > 0 and player(p,[[team]]) == player(p_,[[team]]) and sh.distance(p,p_,hero.nb_health[id][max][3])) then
								hp = player(p_,[[health]])
								if (hp < player(p_,[[maxhealth]])) then sh.parse(7,p_,hp + hero.nb_health[id][max][1]) end
							end
						end
					end
				end
				if (hero.nb_armor[id]) then
					max = sh.maxup([[nb_armor]], id, up)
					pl.nb_armor[p][id] = pl.nb_armor[p][id] + 1
					if (pl.nb_armor[p][id] >= hero.nb_armor[id][max][2]) then
						pl.nb_armor[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (p_ ~= p and player(p_,[[health]]) > 0 and player(p,[[team]]) == player(p_,[[team]]) and sh.distance(p,p_, hero.nb_armor[id][max][3])) then
								ap = player(p_,[[armor]]) + hero.nb_armor[id][max][1]
								if (ap < 200) then sh.parse(4,p_,ap) elseif (player(p_,[[armor]]) ~= 200) then sh.parse(4,p_,200) end
							end
						end
					end
				end
				if (hero.nb_money[id]) then
					max = sh.maxup([[nb_money]], id, up)
					pl.nb_money[p][id] = pl.nb_money[p][id] + 1
					if (pl.nb_money[p][id] >= hero.nb_money[id][max][2]) then
						pl.nb_money[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (p_ ~= p and player(p_,[[health]]) > 0 and player(p,[[team]]) == player(p_,[[team]]) and sh.distance(p,p_, hero.nb_money[id][max][3])) then
								mn = player(p_,[[money]])
								if (mn < 16000) then sh.parse(8,p_,mn + hero.nb_money[id][max][1]) end
							end
						end
					end
				end
				if (hero.e_nb_damage[id]) then
					max = sh.maxup([[e_nb_damage]], id, up)
					pl.e_nb_damage[p][id] = pl.e_nb_damage[p][id] + 1
					if (pl.e_nb_damage[p][id] >= hero.e_nb_damage[id][max][2]) then
						pl.e_nb_damage[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (player(p_,[[health]]) > 0 and player(p,[[team]]) ~= player(p_,[[team]]) and sh.distance(p,p_, hero.e_nb_damage[id][max][3])) then
								hp = player(p_,[[health]]) - hero.e_nb_damage[id][max][1]
								if (hp > 0) then sh.parse(7,p_,hp) else sh.parse(9,p,[["]]..hero.name[id][sh.maxup([[name]], id, up)]..[["]],p_) end
							end
						end
					end
				end
				if (hero.e_nb_money[id]) then
					max = sh.maxup([[e_nb_money]], id, up)
					pl.e_nb_money[p][id] = pl.e_nb_money[p][id] + 1
					if (pl.e_nb_money[p][id] >= hero.e_nb_money[id][max][2]) then
						pl.e_nb_money[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (player(p_,[[health]]) > 0 and player(p,[[team]]) ~= player(p_,[[team]]) and sh.distance(p,p_, hero.e_nb_money[id][max][3])) then
								mn = player(p_,[[money]])
								sh.parse(8,p_,mn + hero.e_nb_money[id][max][1])
							end
						end
					end
				end
				if (hero.e_nb_speed[id]) then
					max = sh.maxup([[e_nb_speed]], id, up)
					pl.e_nb_speed[p][id] = pl.e_nb_speed[p][id] + 1
					if (pl.e_nb_speed[p][id] >= hero.e_nb_speed[id][max][2]) then
						pl.e_nb_speed[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (player(p_,[[health]]) > 0 and player(p,[[team]]) ~= player(p_,[[team]]) and sh.distance(p,p_, hero.e_nb_speed[id][max][3])) then
								pl.speed[p_] = hero.e_nb_speed[id][max][4] + 1 ; sh.parse(6,p_,pl.t_speed[p_] + hero.e_nb_speed[id][max][1])
							end
						end
					end
				end
				if (hero.nb_speed[id]) then
					max = sh.maxup([[nb_speed]], id, up)
					pl.nb_speed[p][id] = pl.nb_speed[p][id] + 1
					if (pl.nb_speed[p][id] >= hero.nb_speed[id][max][2]) then
						pl.nb_speed[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (p ~= p_ and player(p_,[[health]]) > 0 and player(p,[[team]]) == player(p_,[[team]]) and sh.distance(p,p_, hero.nb_speed[id][max][3])) then
								pl.speed[p_] = hero.nb_speed[id][max][4] + 1 ; sh.parse(6,p_,pl.t_speed[p_] + hero.nb_speed[id][max][1])
							end
						end
					end
				end
				if (hero.nb_info[id]) then
					max = sh.maxup([[nb_info]], id, up)
					pl.nb_info[p][id] = pl.nb_info[p][id] + 1
					if (pl.nb_info[p][id] >= hero.nb_info[id][max][2]) then
						pl.nb_info[p][id] = 0
						for m_, p_ in pairs(player(0,[[table]])) do
							if (p ~= p_ and player(p_,[[health]]) > 0 and player(p,[[team]]) == player(p_,[[team]]) and sh.distance(p,p_, hero.nb_info[id][max][3])) then
								msg2(p_,hero.nb_info[id][max][1])
							end
						end
					end
				end
				if (hero.hook_second[id]) then
					p_id, hero_id, hero_lvl = p, id, n
					sh.expand(hero.hook_second[id][sh.maxup([[hook_second]], id, up)])
				end
			end
		end
	end
end

function sh.set.power_kill(p,v)
	local n, id, hp, ap, mn
	for id, n in pairs(pl.hero[p]) do
		up = sh.up(p, id)
		if (hero.kill_health[id]) then
			max = sh.maxup([[kill_health]], id, up)
			hp = player(p,[[health]])
			if (hp < player(p,[[maxhealth]])) then sh.parse(7,p,hp + hero.kill_health[id][max]) end
		end
		if (hero.kill_armor[id]) then
			max = sh.maxup([[kill_armor]], id, up) ; ap = player(p,[[armor]]) + hero.kill_health[id][max]
			if (ap < 200) then sh.parse(4,p,ap) else sh.parse(4,p,200) end
		end
		if (hero.kill_money[id]) then
			max = sh.maxup([[kill_money]], id, up) ; mn = player(p,[[money]])
			if (mn < 16000) then sh.parse(8,p,mn + hero.kill_money[id][max]) end
		end
		if (hero.e_kill_money[id]) then
			max = sh.maxup([[e_kill_money]], id, up) ; mn = player(v,[[money]])
			if (mn > 0) then sh.parse(8,v,mn - hero.e_kill_money[id][max]) end
		end
		if (hero.kill_info[id]) then msg2(p,hero.kill_info[id][sh.maxup([[kill_info]], id, up)]) end
		if (hero.hook_kill[id]) then
			p_id, v_id, hero_id, hero_lvl = p, v, id, n
			sh.expand(hero.hook_kill[id][sh.maxup([[hook_kill]], id, up)])
		end
	end
end

function sh.set.power_die(p,k,x,y)
	local n, id, mn, hp, ap, up
	for id, n in pairs(pl.hero[p]) do
		up = sh.up(p, id)
		if (hero.die_money[id]) then
			max = sh.maxup([[die_money]], id, up) ; mn = player(p,[[money]])
			sh.parse(8,p,mn + hero.die_money[id][max])
		end
		if (hero.e_die_health[id]) then
			max = sh.maxup([[e_die_health]], id, up) ; hp = player(k,[[health]])
			sh.parse(7,k,hp + hero.e_die_health[id][max])
		end
		if (hero.e_die_armor[id]) then
			max = sh.maxup([[e_die_armor]], id, up) ; ap = player(k,[[armor]]) + hero.e_die_armor[id][max]
			if (ap < 200) then sh.parse(4,k,ap) else sh.parse(4,k,200) end
		end
		if (hero.e_die_money[id]) then
			max = sh.maxup([[e_die_money]], id, up)
			sh.parse(8,k,player(k,[[money]]) + hero.e_die_money[id][max])
		end
		if (hero.die_explosion[id]) then
			max = sh.maxup([[die_explosion]], id, up)
			sh.parse(10,x,y,hero.die_explosion[id][max][1],hero.die_explosion[id][max][2], p)
		end
		if (hero.die_info[id]) then msg2(p,hero.die_info[id][sh.maxup([[die_info]], id, up)]) end
		if (hero.hook_die[id]) then
			p_id, k_id, hero_id, hero_lvl = p, k, id, n
			sh.expand(hero.hook_die[id][sh.maxup([[hook_die]], id, up)])
		end
	end
end

function sh.set.power_hit(p, v, w, hp, ap)
	local hit, n, id, max, dmg = 0
	local health, armor, mn, e_mn = player(v,[[health]]) - hp, player(v,[[armor]]) - ap, 0, 0
	for id, n in pairs(pl.hero[p]) do
		up = sh.up(p, id)
		if (hero.damage1[id]) then
			hit = 1 ; max = sh.maxup([[damage1]], id, up) ; dmg = hero.damage1[id][max][2]
			if (hero.damage1[id][max][1] == 0 or hero.damage1[id][max][1] == w) then
				if (ap > 0) then
					armor = armor - dmg
				elseif (hp > 0) then
					health = health - dmg
				end
			elseif (hero.damage1[id][max][1] == 0) then
				if (ap > 0) then
					armor = armor - dmg
				elseif (hp > 0) then
					health = health - dmg
				end
			end
		end
		if (hero.damage2[id]) then
			hit = 1 ; max = sh.maxup([[damage2]], id, up) ; dmg = hero.damage2[id][max][2] * (itemtype(w,[[dmg]]) / 100)
			if (hero.damage2[id][max][1] == 0 or hero.damage2[id][max][1] == w) then
				if (ap > 0) then
					armor = armor - dmg
				elseif (hp > 0) then
					health = health - dmg
				end
			elseif (hero.damage2[id][max][1] == 0) then
				if (ap > 0) then
					armor = armor - dmg
				elseif (hp > 0) then
					health = health - dmg
				end
			end
		end
		if (hero.hit_money[id]) then
			max = sh.maxup([[hit_money]], id, up) ; mn = mn + hero.hit_money[id][max]
		end
		if (hero.e_hit_money[id]) then
			max = sh.maxup([[e_hit_money]], id, up) ; e_mn = e_mn + hero.e_hit_money[id][max]
		end
		if (hero.e_hit_speed[id]) then
			max = sh.maxup([[e_hit_speed]], id, up)
			if (hero.e_hit_speed[id][max][1] == 0 or hero.e_hit_speed[id][max][1] == w) then
				pl.speed[v] = hero.e_hit_speed[id][max][3] + 1 ; sh.parse(6,v,pl.t_speed[v] + hero.e_hit_speed[id][max][2])
			end
		end
		if (hero.hook_hit[id]) then
			p_id, hero_id, wpn_id, v_id, hp_dmg, ap_dmg, hero_lvl = p, id, w, v, hp, ap, n
			sh.expand(hero.hook_hit[id][sh.maxup([[hook_hit]], id, up)])
		end
	end
	if (hit > 0) then
		if (health > 0) then
			sh.parse(7,v,health) ; sh.parse(4,v,armor)
		else
			sh.parse(9,p,[["]]..itemtype(w,[[name]])..[["]],v)
		end
	end
	if (mn > 0) then sh.parse(8,p,player(p,[[money]]) + mn) end
	if (e_mn > 0) then sh.parse(8,v,player(v,[[money]]) + e_mn) end
	return hit
end

function sh.set.power_attack(p, w)
	local m, id, n
	for id, n in pairs(pl.hero[p]) do
		up = sh.up(p, id)
		if (hero.throw_grenade[id]) then
			max = sh.maxup([[throw_grenade]], id, up)
			if (hero.throw_grenade[id][max][2] == 0 or w == hero.throw_grenade[id][max][2]) then
				if (hero.throw_grenade[id][max][4] > 0) then m = 1 else m = 0 end
				if (hero.throw_grenade[id][max][6] > 0) then sh.parse(11,p, w) end
				if (pl.throw_grenade[p][id] or hero.throw_grenade[id][max][6] > 0) then
					pl.throw_grenade[p][id] = nil
					sh.object_add(p, hero.throw_grenade[id][max][1], hero.throw_grenade[id][max][3], m, hero.throw_grenade[id][max][5], hero.throw_grenade[id][max][7], 0, 1, w)
				end
			end
		end
		if (hero.throw_weapon[id]) then
			max = sh.maxup([[throw_weapon]], id, up)
			if (hero.throw_weapon[id][max][2] == 0 or w == hero.throw_weapon[id][max][2]) then
				if (hero.throw_weapon[id][max][5] > 0) then sh.parse(11,p, w) end
				if (pl.throw_weapon[p][id] or hero.throw_weapon[id][max][5] > 0) then
					pl.throw_weapon[p][id] = nil
					sh.object_add(p, hero.throw_weapon[id][max][1], hero.throw_weapon[id][max][3], 1, hero.throw_weapon[id][max][4], 13, hero.throw_weapon[id][max][6], 2, w)
				end
			end
		end
		if (hero.hook_attack[id]) then
			p_id, hero_id, wpn_id, hero_lvl = p, id, w,n
			sh.expand(hero.hook_attack[id][sh.maxup([[hook_attack]], id, up)])
		end
	end
end

function sh.set.power_attack2(p, w)
	local m, id, n, o, s
	for id, s in pairs(pl.hero[p]) do
		up = sh.up(p, id)
		if (hero.throw_grenade[id]) then
			max = sh.maxup([[throw_grenade]], id, up)
			if (hero.throw_grenade[id][max][8] > 0 and (hero.throw_grenade[id][max][2] == 0 or w == hero.throw_grenade[id][max][2])) then
				local del, nx, ny = {}
				if (sh_objects > 0) then
					for o, n in pairs(obj.img) do
						if (obj.id[o] == p) then
							table.insert(del, o)
							sh.parse(10,obj.x[o],obj.y[o],obj.dmg[o], obj.dmg[o], obj.id[o])
						end
					end
				end
				
				for o, n in pairs(del) do sh.object_remove(n) end
			end
		end
	end
end

function sh.set.power_use(p, id)
	if (sh_item.use_health[id]) then sh.parse(7,p,player(p, [[health]]) + sh_item.use_health[id]) end
	if (sh_item.use_armor[id]) then sh.parse(4,p,player(p, [[armor]]) + sh_item.use_armor[id]) end
	if (sh_item.use_speed[id]) then
		if (sh_item.use_speed[id][2] > 0) then
			sh.parse(6,p,player(p, [[speedmod]]) + sh_item.use_speed[id][1])
		else
			sh.parse(6,p,sh_item.use_speed[id][1])
		end
	end
	if (sh_item.use_explosion[id]) then
		sh.parse(10,player(p,[[x]]),player(p,[[y]]),sh_item.use_explosion[id][1],sh_item.use_explosion[id][2], p)
	end
	if (sh_item.hook_use[id]) then
		p_id, item_id = p, id
		sh.expand(sh_item.hook_use[id])
	end
end

function sh.set.power_build(p, type, x, y)
	for id, s in pairs(pl.hero[p]) do
		up = sh.up(p, id)
		if (hero.hook_build[id]) then
			p_id, hero_id, hero_lvl, type_id, type_x, type_y = p, id, s, type, x, y
			sh.expand(hero.hook_build[id][sh.maxup([[hook_build]], id, up)])
		end
	end
	
end