---------------------------------------
-- Console Commands Initialization   --
---------------------------------------

function sh.con.cmd.list_console()
	local i = 0
	sh.print(1,[[===== Console Commands List =====]])
	for id, n in pairs(sh.con.cmd) do
		i = i + 1 ; sh.print(1,i..[[. sh_]]..id..sh.con.info[id][1])
	end
end

function sh.con.cmd.list_players()
	sh.print(1,[[===== Players List =====]])
	for n, id in pairs(player(0,[[table]])) do
		sh.print(1, n..[[. ]]..player(id,[[name]])..[[  |  Level: ]]..pl.stat[id][5]..[[  |  Experience: (]]..pl.stat[id][1]..[[/]]..pl.stat[id][4]..[[)]]..[[  |  Points: ]]..pl.stat[id][2]..[[  |  Credits: ]]..pl.stat[id][3])
	end
end

function sh.con.cmd.list_say()
	local i = 0
	sh.print(1,[[===== Say Commands List =====]])
	for cmd, n in pairs(sh.say.cmd) do		
		if (sh.say.info[cmd]) then
			i = i + 1 ; sh.print(1,i..[[. !]]..cmd..sh.say.info[cmd][1])
		end
	end
end

function sh.con.cmd.list_heroes()
	sh.print(1,[[===== Heroes List =====]])
	for id, n in pairs(hero.name) do
		sh.print(1,id..[[. ]]..n[1]..[[  -  ]]..hero.info[id][1])
	end
end


function sh.con.cmd.list_items()
	sh.print(1,[[===== Items List =====]])
	for id, n in pairs(sh_item.name) do
		sh.print(1,id..[[. ]]..n..[[  -  ]]..sh_item.info[id])
	end
end

function sh.con.cmd.list_config()
	local par
	sh.print(1,[[===== Config Functions List =====]])
	for id, n in pairs(cfg.h_func) do
		par = [[ ]]
		for i = 1, cfg.h_func[id][2] do par = par..[[= [+] ]] end
		sh.print(1,id..[[. ]]..n[1]..par)
	end
end

function sh.con.cmd.list_functions()
	local i = 0
	sh.print(1,[[===== Super Hero Functions List =====]])
	for id, n in pairs(sh) do
		i = i + 1 ; sh.print(1,i..[[. ]]..id..[[ ( ]]..type(n)..[[ )]])
	end
end

function sh.con.cmd.list_lua()
	local i = 0
	sh.print(1,[[===== Super Hero Functions List =====]])
	for id, n in pairs(_G) do
		i = i + 1 ; sh.print(1,i..[[. ]]..id..[[ ( ]]..type(n)..[[ )]])
	end
end

function sh.con.cmd.give_xp(t)
	local p, xp = tonumber(t[1]), tonumber(t[2])
	if (p and xp and player(p, [[exists]])) then
		pl.stat[p][1] = pl.stat[p][1] + xp
		sh.msg(1, [[Admin Gave ]]..player(p,[[name]])..[[ ]]..xp..[[ Exp!]])
		sh.msg2(p,1,[[Admin Gave You ]]..xp..[[ Exp!@C]])
		sh.print(1, [[You Gave ]]..xp..[[ Exp For ]]..player(p,[[name]])..[[!]])
		sh.levelup(p)
		sh.pl_save(p)
		sh.update.hud_all(p)
	end
end

function sh.con.cmd.give_lvl(t)
	local p, lvl, i = tonumber(t[1]), tonumber(t[2])
	if (p and lvl and player(p, [[exists]])) then
		for i = 1, lvl do
			pl.stat[p][1] = pl.stat[p][4]
			sh.levelup(p)
		end
		sh.msg(1, [[Admin Gave ]]..player(p,[[name]])..[[ ]]..lvl..[[ Level!]])
		sh.msg2(p,1,[[Admin Gave You ]]..lvl..[[ Level!@C]])
		sh.print(1, [[You Gave ]]..lvl..[[ Level For ]]..player(p,[[name]])..[[!]])
		sh.pl_save(p)
		sh.update.hud_all(p)
	end
end

function sh.con.cmd.give_pt(t)
	local p, pt = tonumber(t[1]), tonumber(t[2])
	if (p and pt and player(p, [[exists]])) then
		pl.stat[p][2] = pl.stat[p][2] + pt
		sh.msg(1, [[Admin Gave ]]..player(p,[[name]])..[[ ]]..pt..[[ Points!]])
		sh.msg2(p,1,[[Admin Gave You ]]..pt..[[ Points!@C]])
		sh.print(1, [[You Gave ]]..pt..[[ Level For ]]..player(p,[[name]])..[[!]])
		sh.pl_save(p)
		sh.update.hud_all(p)
	end
end

function sh.con.cmd.give_credits(t)
	local p, cr = tonumber(t[1]), tonumber(t[2])
	if (p and cr and player(p, [[exists]])) then
		sh.increase_credits(p, cr)
		sh.msg(1, [[Admin Gave ]]..player(p,[[name]])..[[ ]]..cr..[[ Credits!]])
		sh.msg2(p,1,[[Admin Gave You ]]..cr..[[ Credits!@C]])
		sh.print(1, [[You Gave ]]..cr..[[ Credits For ]]..player(p,[[name]])..[[!]])
		sh.pl_save(p)
		sh.update.hud_all(p)
	end
end

function sh.con.cmd.set_lvl(t)
	local p, lvl = tonumber(t[1]), tonumber(t[2])
	if (p and lvl and player(p, [[exists]])) then
		pl.stat[p][1] = sh_xp_start --XP START
		pl.stat[p][2] = sh_pt_start
		pl.stat[p][4] = sh_lvl_ratio
		pl.stat[p][5] = sh_lvl_start
		while (pl.stat[p][5] < lvl and pl.stat[p][5] < sh_lvl_max) do
			pl.stat[p][1] = pl.stat[p][1] + (pl.stat[p][4] - pl.stat[p][1])
			sh.levelup(p)
		end
		sh.msg(1, [[Admin Set ]]..player(p,[[name]])..[[ Level To ]]..lvl..[[!]])
		sh.msg2(p,1,[[Admin Set Your Level To ]]..lvl..[[!@C]])
		sh.print(1, [[You Set ]]..lvl..[[ Level For ]]..player(p,[[name]])..[[!]])
		sh.pl_save(p)
		sh.update.hud_all(p)
	end
end

function sh.con.cmd.set_xp(t)
	local p, xp = tonumber(t[1]), tonumber(t[2])
	if (p and xp and player(p, [[exists]])) then
		pl.stat[p][1] = xp ; pl.stat[p][2] = sh_pt_start ; pl.stat[p][4] = sh_lvl_ratio ; pl.stat[p][5] = sh_lvl_start
		sh.levelup(p)
		sh.msg(1, [[Admin Set ]]..player(p,[[name]])..[[ Exp To ]]..xp..[[!]])
		sh.msg2(p,1,[[Admin Set Your Exp To ]]..xp..[[!@C]])
		sh.print(1, [[You Set ]]..xp..[[ Exp For ]]..player(p,[[name]])..[[!]])
		sh.pl_save(p)
		sh.update.hud_all(p)
	end
end

function sh.con.cmd.set_credits(t)
	local p, cr = tonumber(t[1]), tonumber(t[2])
	if (p and cr and player(p, [[exists]])) then
		sh.set_credits(p, cr)
		sh.msg(1, [[Admin Set ]]..player(p,[[name]])..[[ Credits To ]]..cr..[[!]])
		sh.msg2(p,1,[[Admin Set Your Credits To ]]..cr..[[!@C]])
		sh.print(1, [[You Set ]]..cr..[[ Credits For ]]..player(p,[[name]])..[[!]])
		sh.pl_save(p)
		sh.update.hud_all(p)
	end
end


function sh.con.cmd.give_all_credits(t)
	local cr, p = tonumber(t[1])
	if cr then
		for n, p in pairs(player(0,[[table]])) do
			sh.increase_credits(p, cr)
			sh.update.hud_all(p)
			sh.pl_save(p)
		end
		sh.msg(1,[[Admin Gave Everyone Credits To ]]..cr..[[!]])
		sh.print(1, [[You Gave ]]..cr..[[ Credits For Everyone!]])
	end
end

function sh.con.cmd.set_all_credits(t)
	local cr, p = tonumber(t[1])
	if cr then
		for n, p in pairs(player(0,[[table]])) do
			sh.set_credits(p, cr)
			sh.update.hud_all(p)
			sh.pl_save(p)
		end
		sh.msg(1,[[Admin Set Everyone Credits To ]]..cr..[[!]])
		sh.print(1, [[You Set ]]..cr..[[ Credits For Everyone!]])
	end
end