-------------------------
-- SuperHero Functions --
-------------------------

function sh.update.hud_lvl(p)
	sh.hudtxt2(p, 2, 3, [[LVL: ]]..pl.stat[p][5]..[[/]]..sh_lvl_max..[[${spc}EXP: (]]..pl.stat[p][1]..[[/]]..pl.stat[p][4]..[[)${spc}PTS: ]]..pl.stat[p][2]..[[${spc}CREDITS: ]]..pl.stat[p][3]..[[/]]..sh_credits_max, 5, 430, 0)
end

function sh.update.hud_login(p)
	local usgn = player(p,[[usgn]])
	if (user.login[p]) then
		sh.hudtxt2(p, 3, 4, [[LOGIN: ]]..user.name[p]..[[ (User)]], 5, 415, 0)
	elseif (usgn > 0) then
		sh.hudtxt2(p, 3, 4, [[LOGIN: #]]..usgn, 5, 415, 0)
	else
		sh.hudtxt2(p, 3, 2, [[Failed To LOGIN!]], 5, 415, 0)
	end
end

function sh.set.player(p)
	for i = 1, 5 do pl.stat[p][i] = cfg.parse[i] end
end

function sh.update.hud_all(p)
	sh.update.hud_lvl(p)
	sh.update.hud_login(p)
end

function sh.update.title(p)
	sh.hudtxt2(p, 0, 4, [[Classic SuperHero (1.0b)]], 320, 5, 1)
	sh.hudtxt2(p, 1, 5, [[${return game("sv_name")} Server]], 320, 20, 1)
end

function sh.maxup(t, id, lvl)
	local power = 1
	if (hero.name[id]) then
		for i = 1, lvl, 1 do
			if (hero[t][id][i]) then power = i end
		end		
	end
	return power
end

function sh.levelup(p, up)
	while (pl.stat[p][1] >= pl.stat[p][4] and pl.stat[p][5] < sh_lvl_max) do
		pl.stat[p][5] = pl.stat[p][5] + 1
		pl.stat[p][4] = pl.stat[p][4] + (pl.stat[p][5] * sh_lvl_ratio)
		pl.stat[p][2] = pl.stat[p][2] + sh_pt_lvl
		if up then
			sh.msg2(p,1,[[You Reached New Level!@C]])
			sh.msg(8,player(p,[[name]])..[[ Reached ]]..pl.stat[p][5]..[[ Level!]])
			sh.snd2(p,[[levelup]])
		end
		if (sh_unlock_msg > 0) then sh.unlocking(p) end
	end
end

function sh.killing(p, v)
	pl.stat[p][1] = pl.stat[p][1] + sh_xp_kill
	sh.increase_credits(p, sh_credits_kill)
	if (sh_extra_xp_higher > 0 and pl.stat[v][5] > pl.stat[p][5]) then
		sh.extra_xp(p, sh_extra_xp_higher * (pl.stat[v][5] - pl.stat[p][5]), [[Killed Stronger Player]])
	end
end

function sh.save_pl_usgn(p)
	local usgn, f = player(p,[[usgn]])
	if (usgn > 0) then
		f = assert(io.open(sh_dir..[[data/usgn_stats/]]..usgn..[[.txt]],[[w]]))
		f:write(pl.stat[p][1].."\n"..pl.stat[p][3])
		f:close()
	end
end

function sh.load_pl_usgn(p)
	local usgn, n_xp, i = player(p,[[usgn]]), sh_lvl_ratio
	if (usgn > 0) then
		sh.msg2(p,5,[[Your U.S.G.N. ID: ]]..usgn..[[@C]])
		local f = io.open(sh_dir..[[data/usgn_stats/]]..usgn..[[.txt]],[[r]])
		if f then
			sh.msg2(p,1,[[Your Save File Found!@C]]) ; i = 0
			for line in f:lines() do
				i = i + 1
				if (i == 1) then
					pl.stat[p][1] = tonumber(line)
				elseif (i == 2) then
					pl.stat[p][3] = tonumber(line)
				else
					break
				end
			end
			f:close()
			i = 1
			while (pl.stat[p][1] >= n_xp and i < sh_lvl_max) do
				i = i + 1
				n_xp = n_xp + (sh_lvl_ratio * i)
			end
			pl.stat[p][2] = sh_pt_start + (sh_pt_lvl * (i - 1))
			pl.stat[p][4] = n_xp ; pl.stat[p][5] = i
			if (sh_save_heroes > 0) then sh.load_hero_usgn(p) end
			if (sh_save_items > 0) then sh.load_item_usgn(p) end
			
		else
			sh.msg2(p,2,[[Failed To Load Save!@C]])
		end
	else
		sh.msg2(p,2,[[Please Check Your U.S.G.N. Account Settings!@C]])
	end
	if (not pl.stat[p][1] or pl.stat[p][1] < 1 or usgn < 1) then sh.set.player(p) end
end

function sh.user_load(p, name)
	local n_xp, i, f = sh_lvl_ratio ; pl.stat[p][1] = nil
	f = io.open(sh_dir..[[data/user_stats/]]..name..[[.txt]],[[r]])
	if f then
		user.name[p] = name
		sh.msg2(p,1,[[Your Save File Found!@C]]) ; i = 0
		for line in f:lines() do
			i = i + 1
			if (i == 1) then
				user.password[p] = line
			elseif (i == 2) then
				pl.stat[p][1] = tonumber(line)
			elseif (i == 3) then
				pl.stat[p][3] = tonumber(line)
			else
				break
			end
		end
		f:close()
		i = 1
		while (pl.stat[p][1] >= n_xp and i < sh_lvl_max) do
			n_xp = n_xp + (sh_lvl_ratio * i)
			i = i + 1
		end
		pl.stat[p][2] = sh_pt_start + (sh_pt_lvl * (i - 1))
		pl.stat[p][4] = n_xp ; pl.stat[p][5] = i
		if (sh_save_heroes > 0) then sh.load_hero_user(p) end
		if (sh_save_items > 0) then sh.load_item_user(p) end
		
	else
		sh.msg2(p,2,[[Failed To Load Save!@C]])
	end
	if (not pl.stat[p][1] or pl.stat[p][1] < 1) then sh.set.player(p) end
end

function sh.load_hero_usgn(p)
	local usgn, list, i, n = player(p , [[usgn]]), [[]]
	if (usgn > 0) then
		local f = io.open(sh_dir..[[data/usgn_heroes/]]..usgn..[[.txt]],[[r]])
		if f then
			sh.msg2(p,1,[[Heroes List File Found!@C]]) ; i = 0
			for line in f:lines() do
				list = line
				if (#list > 0) then
					for i = 1, #list, 1 do
						n  = string.byte(string.sub(list, i, i))
						if (hero.name[n]) then sh.menu_heroes(p,n, 1) end
						if (i > sh_max_heroes) then break end
					end
				end
			end
			f:close()
		else
			sh.msg2(p,2,[[Failed To Selected Heroes List!@C]])
		end
	end
end

function sh.load_hero_user(p)
	local name,list, i, n = user.name[p], [[]]
	local f = io.open(sh_dir..[[data/user_heroes/]]..name..[[.txt]],[[r]])
	if f then
		sh.msg2(p,1,[[Heroes List File Found!@C]]) ; i = 0
		for line in f:lines() do
			list = line
			if (#list > 0) then
				for i = 1, #list, 1 do
					n  = string.byte(string.sub(list, i, i))
					if (hero.name[n]) then sh.menu_heroes(p,n, 1) end
					if (i > sh_max_heroes) then break end
				end
			end
		end
		f:close()
	else
		sh.msg2(p,2,[[Failed To Selected Heroes List!@C]])
	end
end

function sh.load_item_usgn(p)
	local usgn, list, i, n = player(p , [[usgn]]), [[]]
	if (usgn > 0) then
		local f = io.open(sh_dir..[[data/usgn_items/]]..usgn..[[.txt]],[[r]])
		if f then
			sh.msg2(p,1,[[Items List File Found!@C]]) ; i = 0
			for line in f:lines() do
				list = line
				if (#list > 0) then
					for i = 1, #list, 1 do
						n  = string.byte(string.sub(list, i, i))
						sh.select.load_item(p, n)
						if (i > sh_max_items) then break end
					end
				end
			end
			f:close()
		else
			sh.msg2(p,2,[[Failed To Selected Items List!@C]])
		end
	end
end

function sh.load_item_user(p)
	local name,list, i, n = user.name[p], [[]]
	local f = io.open(sh_dir..[[data/user_items/]]..name..[[.txt]],[[r]])
	if f then
		sh.msg2(p,1,[[Items List File Found!@C]]) ; i = 0
		for line in f:lines() do
			list = line
			if (#list > 0) then
				for i = 1, #list, 1 do
					n  = string.byte(string.sub(list, i, i))
					sh.select.load_item(p, n)
					if (i > sh_max_items) then break end
				end
			end
		end
		f:close()
	else
		sh.msg2(p,2,[[Failed To Selected Items List!@C]])
	end
end

function sh.save_hero_usgn(p)
	local usgn, f = player(p,[[usgn]])
	if (usgn > 0) then
		f = assert(io.open(sh_dir..[[data/usgn_heroes/]]..usgn..[[.txt]],[[w]]))
		for id, n in pairs(pl.hero[p]) do
			for i = 1, n do f:write(string.char(id)) end
		end
		f:close()
	end
end

function sh.save_hero_user(p)
	local name, f = user.name[p]
	if name then
		f = assert(io.open(sh_dir..[[data/user_heroes/]]..name..[[.txt]],[[w]]))
		for id, n in pairs(pl.hero[p]) do
			for i = 1, n do f:write(string.char(id)) end
		end
		f:close()
	end
end

function sh.save_item_usgn(p)
	local usgn, f = player(p,[[usgn]])
	if (usgn > 0) then
		f = assert(io.open(sh_dir..[[data/usgn_items/]]..usgn..[[.txt]],[[w]]))
		for id, n in pairs(pl.item[p]) do
			for i = 1, n do f:write(string.char(id)) end
		end
		f:close()
	end
end

function sh.save_item_user(p)
	local name, f = user.name[p]
	if name then
		f = assert(io.open(sh_dir..[[data/user_items/]]..name..[[.txt]],[[w]]))
		for id, n in pairs(pl.item[p]) do
			for i = 1, n do f:write(string.char(id)) end
		end
		f:close()
	end
end

function sh.user_exist(name)
	local f, exist = io.open(sh_dir..[[data/user_stats/]]..name..[[.txt]],[[r]]), nil
	if f then exist = true ; f:close() end
	return exist
end

function sh.user_password(name,pass)
	local f, right, u_pass = io.open(sh_dir..[[data/user_stats/]]..name..[[.txt]],[[r]]), nil
	if f then
		for line in f:lines() do
			u_pass = split(line,[[ ]])[1]
			break
		end
		f:close()
		if (u_pass and pass == u_pass) then right = true end
	end
	return right
end

function sh.user_write(p)
	local f = assert(io.open(sh_dir..[[data/user_stats/]]..user.name[p]..[[.txt]],[[w]]))
	f:write(user.password[p].."\n"..pl.stat[p][1].."\n"..pl.stat[p][3])
	f:close()
end

function sh.user_create(p)
	local f = assert(io.open(sh_dir..[[data/user_stats/]]..user.name[p]..[[.txt]],[[w]]))
	f:write(user.password[p].."\n"..cfg.parse[1].."\n"..cfg.parse[3])
	f:close()
end

function sh.hero_msg(id, up)
	return hero.name[id][sh.maxup([[name]], id, up)]..[[   -   [Upgrade ]]..(up)..[[/]]..hero.upgrade[id]..[[]  -  ]]..hero.info[id][sh.maxup([[info]], id, up)]
end

function sh.up(p, id, s)
	local up = pl.hero[p][id] or 0
	if (s) then up = up + 1 end
	return up
end

function sh.pl_reset(p)
	pl.hero[p] = {}
	pl.item[p] = {}
	for i = 1, 5 do pl.stat[p][i] = cfg.parse[i] end
end

function sh.unlocking(p)
	for id, n in pairs(hero.name) do
		for i = 1, hero.upgrade[id] do
			if (hero.level[id][sh.maxup([[level]], id, i)] == pl.stat[p][5]) then
				sh.msg2(p,7,[[You Have Unlocked ]]..n[sh.maxup([[name]], id, i)]..[[ [Upgrade ]]..i..[[/]]..hero.upgrade[id]..[[] ]])
			end
		end
	end
end

function sh.quake_kill(p,v,w)
	if (os.clock() - ut.timer[p]  > 5) then ut.level[p] = 0 end
	ut.level[p] = ut.level[p] + 1
	ut.timer[p] = os.clock()
	if (ut.level[p] > 1) then sh.extra_xp(p, sh_extra_xp_inrow * (ut.level[p] - 1), [[ Killed ]]..ut.level[p]..[[ In Row!]]) end
	if (sh_quake > 0) then
		local txt = player(p,[[name]])..[[: ]]
		if (ut.level[p] > 1 and ut.level[p] < #ut.kill + 1) then
			sh.msg(5,txt..ut.kill[ut.level[p] - 1]..[[!]])
			sh.snd_quake(ut.kill[ut.level[p] - 1])
		elseif (ut.level[p] >= #ut.kill + 1) then
			sh.msg(5,txt..ut.kill[#ut.kill]..[[!]])
			sh.snd_quake(ut.kill[#ut.kill])
		end
		if (not ut.blood) then
			sh.msg(5,txt..[[Sheds First Blood!]])
			sh.snd_quake([[firstblood]])
			ut.blood = true
		end
		if (w == 50) then
			sh.msg(5,txt..[[Knifed ]]..player(v,[[name]])..[[!]])
			sh.snd_quake([[humiliation]])	
		end
	end
	if (w == 50) then sh.extra_xp(p, sh_extra_xp_knife, [[Knifed Player]]) end
end

function sh.help_show(p)
	if not pl.help[p] then
		local i
		for i = 1, #help.line do sh.hudtxt2(p,25 + i,6,help.line[i],490,25 + 15 * i,0) end
		pl.help[p] = true
	else
		sh.msg2(p, 2,[[Help Is Already Opened!]])
	end
end

function sh.help_hide(p)
	if (pl.help[p]) then
		for i = 1, #help.line do sh.hudtxt2(p,25 + i,1,[[]],0,0,0) end
		pl.help[p] = nil
	else
		sh.msg2(p, 2,[[Help Is Already Closed!]])
	end
end

function sh.help_open()
	local m, f = 0, io.open(sh_dir..[[help.txt]],[[r]])
	if f then
		sh.print(1,[[Help File Found!]])
		for line in f:lines() do
			m = m + 1 ; help.line[m] = line
		end
		f:close()
	else
		sh.print(2,[[Help File Missing!]])
	end
end

function sh.object_add(p,path, speed, mode, dmg, rad, rot2, type, wpn)
	if (sh_objects > 0) then
		local x, y, rot = player(p, [[x]]), player(p, [[y]]), player(p, [[rot]])
		table.insert(obj.x, x)
		table.insert(obj.y, y)
		table.insert(obj.id, p)
		table.insert(obj.rot, rot)
		table.insert(obj.rot2, rot2)
		table.insert(obj.speed, speed)
		table.insert(obj.dmg, dmg)
		table.insert(obj.rad, rad)
		table.insert(obj.type, type)
		table.insert(obj.idle, 0)
		table.insert(obj.wpn, wpn)
		sh.throw_image(p, path, x, y, rot, mode)
	end
end

function sh.object_remove(id)
	if (obj.img[id]) then freeimage(obj.img[id]) end
	for k, v in pairs(obj) do table.remove(obj[k], id) end
end

function sh.obj_update()
	local del, nx, ny = {}
	if (sh_objects > 0) then
		for id, n in pairs(obj.img) do
			nx = obj.x[id] + cos(obj.rot[id] - 90) * obj.speed[id]
			ny = obj.y[id] + sin(obj.rot[id] - 90) * obj.speed[id]
			if sh.throw_collide(nx, ny) then
				if (obj.type[id] == 1) then
					sh.parse(10,obj.x[id],obj.y[id],obj.dmg[id],obj.dmg[id], obj.id[id])
					table.insert(del, id)
				else
					obj.speed[id] = 0
				end
			else
				obj.x[id] = nx ; obj.y[id] = ny
				if (obj.rot2[id] > 0) then obj.rot2[id] = obj.rot2[id] + 45 end
				if (obj.speed[id] > 0) then
					imagepos(n, obj.x[id], obj.y[id], obj.rot[id] + obj.rot2[id])
				else
					obj.idle[id] = obj.idle[id] + 1
					for m, p in pairs(player(0,[[table]])) do
						if (p == obj.id[id] and sh.obj_dist(obj.x[id], obj.y[id], p, obj.rad[id])) then
							sh.parse(5,p, obj.wpn[id])
							sh.parse(12,p, obj.wpn[id])
							table.insert(del, id)
						end
					end
				end
				if (obj.idle[id] > sh_objects_idle) then
					table.insert(del, id)
				else
					for m, p in pairs(player(0,[[table]])) do
						if ( player(p, [[health]]) > 0 and player(p, [[team]]) ~= player(obj.id[id],[[team]]) and sh.obj_dist(obj.x[id], obj.y[id], p, obj.rad[id])) then
							table.insert(del, id)
							if (obj.type[id] == 1) then
								sh.parse(10,obj.x[id],obj.y[id],obj.dmg[id], obj.dmg[id], obj.id[id])
							else
								sh.parse(9,obj.id[id],[["Throwable ]]..itemtype(obj.wpn[id],[[name]])..[["]],p)
							end
						end
					end
				end
				
			end
		end
		for id, n in pairs(del) do sh.object_remove(n) end
	end
end

function sh.remove.pl_images(p)
	for id, n in pairs(pl.img_oval[p]) do freeimage(n) end
	pl.img_oval[p] = {}
end

function sh.member.add(t, ln)
	local args, usgn, name , color
	if (string.sub(t,1, 10) == [[#addmember]]) then
		args =  split(t,[[:]])
		if (#args == 5) then
			usgn = sh.member.check(tonumber(args[2]), ln, 1)
			name = sh.member.check(args[3], ln)
			rank = sh.member.check(args[4], ln)
			color = sh.member.check(args[5], ln)
			if #color ~= 9 then color = [[]] end
			sh.member.rank[usgn] = rank
			sh.member.color[usgn] = color
			sh.member.name[usgn] = name
			print([[]]..color..[[Member Added: Name = ]]..name..[[ | U.S.G.N. = ]]..usgn..[[ | Rank = ]]..rank)	
		end
	end
end

function sh.member.load()
	local f, i = io.open(sh_dir..[[members.cfg]],[[r]]), 0
	if f then
		sh.print(1,[[Members Ranks File Found!]])
		sh.print(1,[[=== Members List ===]])
		for line in f:lines() do
			i = i + 1
			sh.member.add(line, i)
		end
		sh.print(1,[[=== End Of Members List ===]])
		f:close()
	else
		sh.print(2,[[Member List File Missing!]])
	end
end

function sh.member.check(v, ln, number)
	if number then
		if not v then v = 1 ; sh.member.error(4,ln) end
	else
		if not v then v = [[None]] ; sh.member.error(4,ln) end
	end
	return v
end

function sh.round_equip(p)
	local last = 0
	if (sh_weaponrounds > 0) then
		for m, n in pairs(round[sh.round.current]) do
			sh.parse(5,p,n)
			last = n
		end
		sh.parse(12,p,last)
	end
end

function sh.round_set(p)
	local txt = [[]]
	if (sh_weaponrounds > 0) then
		for m, p in pairs(player(0,[[table]])) do
			if (player(p,[[health]]) > 0) then
				for k, l in pairs(round[sh.round.current]) do
					sh.parse(11, p, l)
				end
			end
		end
		sh.round.current = math.random(1, #round)
		for m, n in pairs(round[sh.round.current]) do
			if m > 1 then txt = txt..[[ & ]] end
			txt = txt..itemtype(n,[[name]])
		end
		sh.msg(5,txt..[[ Round!@C]])
		for m, p in pairs(player(0,[[table]])) do
			if (player(p,[[health]]) > 0) then
				sh.round_equip(p)
			end
		end
	end
end

function sh.extra_xp(p, xp, msg)
	if (xp > 0) then
		sh.msg2(p,4,[[You ]]..msg..[[!@C]])
		sh.msg2(p,5,[[You Get Extra ]]..xp..[[ EXP!@C]])
		pl.stat[p][1] = pl.stat[p][1] + xp
		sh.levelup(p, 1)
		sh.update.hud_all(p)
		sh.pl_save(p)
	end
end

function sh.badwords_open()
	local f = io.open(sh_dir..[[badwords.cfg]],[[r]])
	if f then
		sh.print(1,[[BadWords File Found!]])
		for line in f:lines() do
			for id, txt in pairs(split(line,[[,]])) do
				table.insert(badwords, txt)
			end
			
		end
		f:close()
	else
		sh_badwords = 0
		sh.print(2,[[Bad Words File Missing!]])
	end
end

function sh.search.badwords(p, t)
	local hide, i, id, txt, m  = 0
	local function flame()
		m = false
		for id, txt in pairs(badwords) do
			if string.find(t, txt) then
				for i = 1, #t do
					if string.sub(t, i, i + #txt - 1) == txt then
						t = string.sub(t, 1, i - 1)..string.rep([[*]], #txt)..string.sub(t, i + #txt)
						hide = 1 ; m = true
						break
					end
				end
			end
		end
		return m
	end
	while flame() do
		-- {{ Nothing }} --
	end
	if hide == 1 then
		sh.msg(2, player(p,[[name]])..[[ said: ]]..t)
		sh.parse(13, p)
	end
	return hide
end

function sh.pl_save(p)
	if user.login[p] then
		sh.user_write(p)
	else
		sh.save_pl_usgn(p)
	end
end

function sh.pl_save_heroes(p)
	if user.login[p] then
		sh.save_hero_user(p)
	else
		sh.save_hero_usgn(p)
	end
end

function sh.pl_save_items(p)
	if user.login[p] then
		sh.save_item_user(p)
	else
		sh.save_item_usgn(p)
	end
end

function sh.select.load_item(p, id)
	if (sh_item.name[id]) then
		local up = pl.item[p][id] or 0
		if (up > 0) then
			pl.item[p][id] = up + 1
		else
			pl.item[p][id] = 1
		end
	end
end

function sh.increase_credits(p, cr)
	if (sh_credits_max > pl.stat[p][3] + cr) then
		pl.stat[p][3] = pl.stat[p][3] + cr
	else
		pl.stat[p][3] = sh_credits_max
	end
end

function sh.set_credits(p, cr)
	if (sh_credits_max > cr) then
		pl.stat[p][3] = cr
	else
		pl.stat[p][3] = sh_credits_max
	end
end

function sh.build(p, id)
	if building.name[id] then
		local x, y
		for x = 0, building.x[id] do
			for y = 0, building.y[id] do
				if (building.pos[id][x][y] and building.pos[id][x][y] > 0) then
					sh.setbuilding(building.pos[id][x][y],player(p,[[tilex]]) + x - 1 - building.c_x[id], player(p,[[tiley]]) + y - building.c_y[id], p)
				end
			end
		end
	else
		sh.msg( 2, [[Error: Building Doesn't Exist!]])
	end
end

function sh.pl_set(p)
	pl.hero[p] = {}
	pl.item[p] = {}
	user.login[p] = nil
	user.name[p] = nil
	user.password[p] = nil
end

function sh.showconfig(p)
	local function con(cfg)
		if cfg and cfg > 0 then return [[On]] else return [[Off]] end
	end
	sh.msg2(p, 1, [[===== Configuration =====]])
	sh.msg2(p, 1, [[Weapon Rounds: ]]..con(sh_weaponrounds))
	sh.msg2(p, 1, [[Bad Words: ]]..con(sh_badwords))
	sh.msg2(p, 1, [[UT & Quake: ]]..con(sh_quake))
	sh.msg2(p, 1, [[Members: ]]..con(sh_members))
	sh.msg2(p, 1, [[SH Objects: ]]..con(sh_objects))
	sh.msg2(p, 1, [[Heroes Saves: ]]..con(sh_save_heroes))
	sh.msg2(p, 1, [[Items Saves: ]]..con(sh_save_items))
end

function sh.buildset()
	parse('mp_building_limit Turret 0')
	parse('mp_building_limit Barricade 0')
	parse('mp_building_limit "Barbed Wire" 0')
	parse('mp_building_limit "Wall I" 0')
	parse('mp_building_limit "Wall II" 0')
	parse('mp_building_limit "Wall III" 0')
	parse('mp_building_limit "Gate Field" 0')
	parse('mp_building_limit Dispenser 0')
	parse('mp_building_limit Supply 0')
	parse('mp_building_limit "Teleporter Exit" 0')
	parse('mp_building_limit "Teleporter Entrance" 0')
end