---------------------
-- SuperHero Hooks --
---------------------

sh.load.heroes(sh.file[1])
sh.load.heroes(sh.file[4])
sh.load.heroes(sh.file[2])
sh.load.heroes(sh.file[3])
sh.help_open()
if (sh_members > 0) then sh.member.load() end
if (sh_badwords > 0) then sh.badwords_open() end

function sh.startrounds()
	pl.img_oval = array_2d(32,sh_max_heroes,nil)
	sh.timer_cnt = 0
	ut.blood = nil
	sh.round_set(p)
end

function sh.endrounds(m)
	m = roundtype[m]
	if m then
		for k, p in pairs(player(0,[[table]])) do
			if (m == player(p, [[team]])) then
				sh.extra_xp(p, sh_extra_xp_winner, [[Won The Round]])
				sh.snd2(p,[[roundwin]])
			elseif (player(p, [[team]]) > m) then
				sh.snd2(p,[[roundlose]])
			end
		end
	end
end

function sh.serveractions(p, a)
	if (a == 1) then
		sh.select.main(p)
	elseif (a == 2) then
		sh.select.main_items(p)
	elseif (a == 3) then
		sh.help_hide(p)
	end
end

function sh.teams(p, t)
	if (not pl.join[p]) then
		pl.join[p] = true
		sh.pl_reset(p)
		sh.load_pl_usgn(p)
		sh.update.title(p)
		sh.update.hud_all(p)
		sh.help_show(p)
	end
end

function sh.joins(p)
	local usgn =  player(p, [[usgn]])
	sh.pl_reset(p)
	pl.join[p] = nil
	user.login[p] = nil
	user.name[p] = nil
	user.password[p] = nil
	pl.help[p] = nil
	if (sh_join_msg > 0) then sh.msg2(p,1,[[Welcome To Classical SuperHero (1.0) Server!@C]]) end
	if (sh.member.name[usgn]) then sh.msg(4,player(p,[[name]])..[[ (]]..sh.member.rank[usgn]..[[) Joined Server]]) end
end

function sh.spawns(p)
	sh.remove.pl_images(p)
	sh.round_equip(p)
	if (player(p,[[team]]) > 0) then
		if (pl.stat[p][2] > 0) then sh.select.hero_menu(p) end
		sh.set.power_spawn(p)
		if player(p,[[bot]]) then
			for i = 1, pl.stat[p][3] do sh.menu_heroes(p,math.random(1,#hero.name)) end
		end
	end
	ut.level[p] = 0
	ut.timer[p] = 0
end

function sh.menus(p, t, s)
	sh.menu_render(p, t, s)
end

function sh.reloads(p, m)
	if (m == 1) then sh.set.power_noreload(p) end
end

function sh.seconds()
	sh.set.power_second()
end

function sh.kills(p, v, w)
	if (player(p,[[team]]) ~= player(v, [[team]])) then
		sh.set.power_kill(p,v)
		sh.killing(p, v)
		sh.levelup(p, 1)
		sh.update.hud_all(p)
		sh.pl_save(p)
		sh.quake_kill(p,v,w)
	end
end

function sh.dies(p, k, w, x, y)
	if (p ~= k and k > 0) then sh.set.power_die(p,k,x,y) end
	sh.remove.pl_images(p)
	ut.timer[p] = 0 ; ut.level[p] = 0
	if (sh_item_droping < 1 and (w < 51 or w > 71)) then return 1 end
end

function sh.ms100s()
	local m, id
	for m, id in pairs(sh.timer) do
		sh.oval_image(id[1],id[2],id[3],id[4],id[5],id[6])
		sh.timer[m] = nil
	end
	sh.obj_update()
end

function sh.says(p, t)
	local c, hide, usgn = split(string.sub(string.lower(t),2),[[ ]]), 0, player(p, [[usgn]])
	if (string.sub(t,1,1) == [[!]] and sh_say > 0) then
		if (sh.say.cmd[c[1]]) then
			if (sh.say.info[c[1]][2] == #c) then
				sh.say.cmd[c[1]](p,split(string.sub(t,2 + #c[1]),[[ ]]))
				hide = 1
			elseif (sh.say.info[c[1]][2] > #c) then
				sh.msg2(p,2,[[Not Enough Parameters! ( !]]..c[1]..[[ ]]..sh.say.info[c[1]][1]..[[ )]])
			elseif (sh.say.info[c[1]][2] < #c) then
				sh.msg2(p,2,[[Too Many Parameters! ( !]]..c[1]..[[ ]]..sh.say.info[c[1]][1]..[[ )]])
			end
		else
			sh.msg2(p,2,[[This Command Doesn't Exist!]])
		end
	elseif sh.member.name[usgn] and t ~= [[rank]] then
		msg([[]]..sh.member.color[usgn]..player(p,[[name]])..[[ (]]..sh.member.rank[usgn]..[[): ]]..t)
		hide = 1
	elseif (sh_badwords > 0) then
		hide = sh.search.badwords(p, string.lower(t))
	end
	return hide
end

function sh.hits(v,p,w,hp,ap)
	if (player(p,[[team]]) ~= player(v,[[team]]) and p > 0 and w < 99) then return sh.set.power_hit(p, v, w, hp, ap) end
end

function sh.attacks(p)
	local w = player(p,[[weapontype]])
	sh.set.power_attack(p, w)
end

function sh.attack2s(p)
	local w = player(p,[[weapontype]])
	sh.set.power_attack2(p, w)
end

function sh.parses(t)
	local c = split(string.sub(string.lower(t),4),[[ ]])
	if (string.sub(t,1, 3) == [[sh_]] and sh_console > 0) then
		if (sh.con.cmd[c[1]]) then
			if (sh.con.info[c[1]][2] == #c) then
				sh.con.cmd[c[1]](split(string.sub(t,4 + #c[1]),[[ ]]))
			elseif (sh.con.info[c[1]][2] > #c) then
				sh.print(2,[[Not Enough Parameters! ( sh_]]..c[1]..[[ ]]..sh.con.info[c[1]][1]..[[ )]])
			elseif (sh.con.info[c[1]][2] < #c) then
				sh.print(2,[[Too Many Parameters! ( sh_]]..c[1]..[[ ]]..sh.con.info[c[1]][1]..[[ )]])
			end
			return 2
		end
	elseif (sh_con_hero_add > 0 and string.sub(t,1,1) == [[#]]) then
		if sh.search.mark(t) then return 2 end
	end
	return 0
end

function sh.bombplants(p)
	sh.extra_xp(p, sh_extra_xp_bombplant, [[Planted A Bomb]])
end

function sh.bombdefuses(p)
	sh.extra_xp(p, sh_extra_xp_bombdefuse, [[Defused Bomb]])
end

function sh.dominates(p)
	sh.extra_xp(p, sh_extra_xp_dominate, [[Dominated Flag]])
end

function sh.flagcaptures(p)
	sh.extra_xp(p, sh_extra_xp_flagcapture, [[Captured The Flag]])
end

function sh.buys(p)
	if (sh_item_buying < 1) then
		sh.msg2(p,2,[[Weapons Buying Disabled!@C]])
		return 1
	end
end

function sh.drops(p,w)
	if ((w < 53 or w > 71) and sh_item_droping < 1) then return 1 end
end

function sh.walkovers(p,id,w)
	if ((w < 51 or w > 71) and sh_item_taking < 1) then return 1 end
end

function sh.leaves(p)
	if (sh_save_heroes > 0) then sh.pl_save_heroes(p) end
	if (sh_save_items > 0) then sh.pl_save_items(p) end
	sh.pl_reset(p)
	sh.pl_set(p)
	sh.remove.pl_images(p)
	pl.join[p], pl.help[p] = nil, nil
end

function sh.mapchanges()
	if sh_save_mapchange > 0 then
		for m, p in pairs(player(0,[[table]])) do
			sh.pl_save(p)
			if (sh_save_heroes > 0) then sh.pl_save_heroes(p) end
			if (sh_save_items > 0) then sh.pl_save_items(p) end
		end
	end
end

function sh.buildattempts(p, t, x, y)
	sh.buildset()
	sh.set.power_build(p, t, x, y)
end