------------------------------
-- Abilities Initialization --
------------------------------

function sh.load.heroes(path)
	local file = io.open(sh_dir..path,[[r]])
	if file then
		sh.load.sucess(path, 1)
		for line in file:lines() do sh.search.mark(line) end
		file:close()
	else
		sh.load.error(path, 1)
	end
end

function sh.search.mark(t)
	local ln, add, m = split(string.lower(t),[[:]])
	if ln[1] then
		ln = split(ln[1],[[ ]])
		if ln[1] then
			m = string.sub(ln[1],2)
			if sh.config[m] then sh.config[m](t) ; add = true end
		end
	end
	return add
end

function sh.config.addhero(t)
	if (#hero.name < sh_max_heroes) then
		local table_, index_, id, i = {[[name]], [[info]], [[point]], [[level]], [[upgrade]]}, {{[[None]]}, {[[N/A]]}, {0}, {1}}
		if (#split(t,[[:]]) > 3) then
			for i = 1, 5 do table.insert(hero[table_[i]], 1) end
			id = #hero.name
			for i = 1, 4 do hero[table_[i]][id] = index_[i] end
			if (sh_config_success > 0) then sh.print(1, [[ - Adding Superhero []]..id..[[] -]]) end
			sh.add.attemt(t,cfg.h_func)
		else
			sh.add.error(1, 1)
		end
	end
end

function sh.config.additem(t)
	if (#sh_item.name < sh_max_items) then
		local table_, index_, id, i = {[[name]], [[info]], [[level]], [[credit]], [[slot]]}, {[[None]], [[N/A]], 0, 0, 1}
		if (#split(t,[[:]]) > 0) then
			if (sh_config_success > 0) then sh.print(1, [[ - Adding Item -]]) end
			for i = 1, 5 do table.insert(sh_item[table_[i]], 1) end
			id = #sh_item.name
			for i = 1, 5 do sh_item[table_[i]][id] = index_[i] end
			sh.add.attemt(t,cfg.i_func,1)
		else
			sh.add.error(1, 1)
		end
	end
end

function sh.config.addround(t)
	local txt, w = [[]]
	t = split(t,[[=]])
	if (#t == 2) then
		table.insert(round, {})
		for k, v in ipairs(split(t[2],[[,]])) do
			w = tonumber(v)
			if (w) then table.insert(round[#round],w) ; txt = txt..itemtype(w,[[name]])..[[ ]] end
		end
		if (sh_config_success > 0) then sh.print(1, [[- Adding Weapon Round -]])
			sh.print(1,[[#addround: ]]..txt)
		end
	elseif (#t > 2) then
		sh.add.error(3, 2)
	else
		sh.add.error(3, 1)
	end
end

function sh.config.addbuilding(t)
	t, id, name = split(split(t,[[=]])[2],[[~]])
	if (#t == 3) then
		name = table.concat(split(t[1],[[ ]]))
		local f = io.open(sh_dir..[[buildings/]]..name,[[r]])
		if f then
			if (sh_config_success > 0) then sh.print(1, [[- Adding Building -]]) end
			table.insert(building.name, name)
			local id = #building.name
			sh.print(1, id..[[. Building: ]]..name)
			building.c_x[id], building.c_y[id] = tonumber(t[2]), tonumber(t[3])
			local x, y, _x = 0, 0, 0
			for line in f:lines() do
				for x = 0, #line do
					if map_chars[string.sub(line, x, x)] then
						building.pos[id][x][y] = map_chars[string.sub(line, x, x)]
					end
				end
				y, _x = y + 1, #line
			end
			building.x[id] = _x
			building.y[id] = y
		else
			sh.add.error(4, 5)
		end
	elseif (#t > 4) then
		sh.add.error(4, 2)
	else
		sh.add.error(4, 1)
	end
end

function sh.config.path(t)
	if (#split(t,[[=]]) == 2) then
		sh.print(1, [[- Searching For SuperHeroes Path -]])
		sh.load.heroes(split(t,[[=]])[2])
	elseif (#split(t,[[=]]) > 2) then
		sh.add.error(2, 2)
	else
		sh.add.error(2, 1)
	end
end

function sh.add.attemt(t, table_, mode)
	local cmd, x, y, m, n = split(t,[[:]]) ; table.remove(cmd, 1)
	for x, m in ipairs(cmd) do
		for y, n in ipairs(table_) do
			if not mode then
				sh.search.hero_func(m, y)
			else
				sh.search.item_func(m, y)
			end
		end
	end
end

function sh.search.hero_func(m, y)
	local cmd , cnt, p, id, up, par = cfg.h_func[y][1], cfg.h_func[y][2]
	if string.find(string.lower(m),cmd) then
		id, p, par = #hero.name, #split(m,[[=]]) - 2 + #split(m,[[~]]) - ((cnt - 1) * (#split(m,[[>]]) - 1)), split(split(m,[[=]])[2],[[>]])
		if (cnt == p) then
			if (hero.upgrade[id] < #par) then hero.upgrade[id] = #par end
			hero[string.sub(cmd,2)][id] = {}
			for up = 1, #par do
				sh.set.hero(split(par[up],[[~]]), id, up, y)
			end
			sh.set.sucess(y, split(m,[[=]]))
		elseif (cnt > p) then
			sh.set.error(y, 1)
		else
			sh.set.error(y, 2)
		end
	end
end

function sh.search.item_func(m, y)
	local cmd , cnt, p, id, up, par = cfg.i_func[y][1], cfg.i_func[y][2]
	if string.find(string.lower(m),cmd) then
		id, p, par = #sh_item.name, #split(m,[[=]]) - 2 + #split(m,[[~]]) - ((cnt - 1) * (#split(m,[[>]]) - 1)), split(m,[[=]])[2]
		if (cnt == p) then
			sh.set.item(split(par,[[~]]), id, y)
			sh.set.sucess(y, split(m,[[=]]))
		elseif (cnt > p) then
			sh.set.error(cmd, 1)
		else
			sh.set.error(cmd, 2)
		end
	end
end

function sh.set.hero(t, id, up, cmd)
	local pw = string.sub(cfg.h_func[cmd][1],2)
	if (cfg.h_func[cmd][2] > 1) then
		hero[pw][id][up] = {}
		for i = 1, cfg.h_func[cmd][2], 1 do
			if (i <= cfg.h_func[cmd][3]) then
				hero[pw][id][up][i] = t[i]
			else
				hero[pw][id][up][i] = tonumber(t[i])
				if not hero[pw][id][up][i] then sh.print(2, [[Heroes Configuration Error: "#]]..pw..[[" (Parameter Should Be Number)]]) end
			end
		end
	else
		if (cfg.h_func[cmd][3] > 0) then
			hero[pw][id][up] = t[1]
	else
			hero[pw][id][up] = tonumber(t[1])
			if not hero[pw][id][up] then sh.print(2, [[Heroes Configuration Error: "#]]..pw..[[" (Parameter Should Be Number)]]) end
		end
	end
end

function sh.set.item(t, id, cmd)
	local pw = string.sub(cfg.i_func[cmd][1],2)
	if (cfg.i_func[cmd][2] > 1) then
		sh_item[pw][id] = {}
		for i = 1, cfg.i_func[cmd][2], 1 do
			if (i <= cfg.i_func[cmd][3]) then
				sh_item[pw][id][i] = t[i]
			else
				sh_item[pw][id][i] = tonumber(t[i])
				if not sh_item[pw][id][i] then sh.print(2, [[Items Configuration Error: "#]]..pw..[[" (Parameter Should Be Number)]]) end
			end
		end
	else
		if (cfg.i_func[cmd][3] > 0) then
			sh_item[pw][id] = t[1]
	else
			sh_item[pw][id] = tonumber(t[1])
			if not sh_item[pw][id] then sh.print(2, [[Items Configuration Error: "#]]..pw..[[" (Parameter Should Be Number)]]) end
		end
	end
end