---------------------------
-- SuperHero Menu Render --
---------------------------

function sh.select.hero_menu(p,t)
	if (t) then t = pl.menu_id[p] + t else t = 1 end
	pl.menu_id[p] = t
	sh.select.hero(p)
end

function sh.select.rehero_menu(p,t)
	if (t) then t = pl.menu_id[p] + t else t = 1 end
	pl.menu_id[p] = t
	sh.select.rehero(p)
end

function sh.select.item_menu(p,t)
	if (t) then t = pl.menu_id[p] + t else t = 1 end
	pl.menu_id[p] = t
	sh.select.item(p)
end

function sh.select.inventory_menu(p,t)
	if (t) then t = pl.menu_id[p] + t else t = 1 end
	pl.menu_id[p] = t
	sh.select.inventory(p)
end

function sh.select.market_menu(p,t)
	if (t) then t = pl.menu_id[p] + t else t = 1 end
	pl.menu_id[p] = t
	sh.select.market(p)
end

function sh.select.main(p)
	local btn = [[,]]
	for i = 1, 8 do btn = btn..men.title[i]..[[,]] end
	menu(p,men.title[9]..btn)
end

function sh.select.main_items(p)
	menu(p,men.title[10]..[[,Inventory|Use Items,Shop|Sell Items,Market|Sell Items]])
end

function sh.select.hero(p)
	local list, id, up = [[]]
	if (pl.menu_id[p] < 2) then
		for id = 1, 8 do
			up = sh.up(p, id, 1)
			if (hero.name[id]) then
				if (hero.level[id][sh.maxup([[level]], id, up)] <= pl.stat[p][5]) then
					list = list..sh.hero_button(id, up)
				else
					list = list..sh.hero_lock(id, up)
				end
			end
		end
		if (#hero.name > 8) then list = list..[[More Heroes|Next Page,]] end
	else
		for id = 9 + ((pl.menu_id[p] - 2) * 7) , 15 + ((pl.menu_id[p] - 2) * 7) do
			up = sh.up(p, id, 1)
			if (hero.name[id]) then
				if (hero.level[id][sh.maxup([[level]], id, up)] <= pl.stat[p][5]) then
					list = list..sh.hero_button(id, up)
				else
					list = list..sh.hero_lock(id, up)
				end
			else
				list = list..[[,]]
			end
		end
		list = list..[[Previous Heroes|Back,]]
		if (#hero.name > 15 + ((pl.menu_id[p] - 2) * 7)) then list = list..[[More Heroes|Next Page,]] end
	end
	menu(p,men.title[1]..[[ [ ]]..pl.stat[p][2]..[[ Points Left ] (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
end

function sh.select.item(p)
	local list, id = [[]]
	function list_add(id)
		if (sh_item.name[id]) then
			if sh_item.hero[id] and hero.name[sh_item.hero[id]] and not pl.hero[p][sh_item.hero[id]] then
				list = list..[[LOCKED|"]]..hero.name[sh_item.hero[id]][1]..[[" Is Required!,]]
			else
				if (sh_item.level[id] <= pl.stat[p][5]) then
					list = list..sh.item_button(p, id)
				else
					list = list..sh.item_lock(id)
				end
			end
		end
	end
	if (pl.menu_id[p] < 2) then
		for id = 1, 8 do list_add(id) end
		if (#sh_item.name > 8) then list = list..[[More Items|Next Page,]] end
	else
		for id = 9 + ((pl.menu_id[p] - 2) * 7) , 15 + ((pl.menu_id[p] - 2) * 7) do
			if (sh_item.name[id]) then
				list_add(id)
			else
				list = list..[[,]]
			end
		end
		list = list..[[Previous Items|Back,]]
		if (#sh_item.name > 15 + ((pl.menu_id[p] - 2) * 7)) then list = list..[[More Item|Next Page,]] end
	end
	menu(p,men.title[3]..[[ [ ]]..pl.stat[p][2]..[[ Credits Left ] (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
end

function sh.select.rehero(p)
	local list, i, h_cnt, cnt, id, up = [[]], 0, sh.heroes_cnt(p), 0
	if (pl.menu_id[p] < 2) then
		for id = 1, #hero.name do
			up = sh.up(p, id)
			if (up > 0 and i < 8) then
				i = i + 1
				list = list..sh.hero_rebutton(id, up)
			end
		end
		if (h_cnt > 8) then list = list..[[More Heroes|Next Page,]] end
		menu(p,men.title[2]..[[ [ ]]..pl.stat[p][2]..[[ Points ] (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
	else
		for id, n in pairs(pl.hero[p]) do
			up = sh.up(p, id)
			cnt = cnt + 1
			if (cnt > 8 + ((pl.menu_id[p] - 2) * 7) and cnt < 16 + ((pl.menu_id[p] - 2) * 7)) then
				i = i + 1
				list = list..sh.hero_rebutton(id, up)
			end
		end
		if (i < 1) then
			 sh.select.rehero_menu(p, -1)
		else
			for m = i, 6 do list = list..[[,]] end
			list = list..[[Previous Heroes|Back,]]
			if (h_cnt > 15 + ((pl.menu_id[p] - 2) * 7)) then list = list..[[More Heroes|Next Page,]] end
			menu(p,men.title[2]..[[ [ ]]..pl.stat[p][2]..[[ Points ] (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
		end
	end
end

function sh.select.inventory(p)
	local list, i, i_cnt, cnt, id, up = [[]], 0, sh.items_cnt(p), 0
	if (pl.menu_id[p] < 2) then
		for id = 1, #sh_item.name do
			up = sh.slot(p, id)
			if (up > 0 and i < 8) then
				i = i + 1
				list = list..sh.item_inv(p, id)
			end
		end
		if (i_cnt > 8) then list = list..[[More Items|Next Page,]] end
		menu(p,men.title[4]..[[ (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
	else
		for id, n in pairs(pl.item[p]) do
			up = sh.up(p, id)
			cnt = cnt + 1
			if (cnt > 8 + ((pl.menu_id[p] - 2) * 7) and cnt < 16 + ((pl.menu_id[p] - 2) * 7)) then
				i = i + 1
				list = list..sh.item_inv(p, id)
			end
		end
		if (i < 1) then
			 sh.select.inventory_menu(p, -1)
		else
			for m = i, 6 do list = list..[[,]] end
			list = list..[[Previous Items|Back,]]
			if (i_cnt > 15 + ((pl.menu_id[p] - 2) * 7)) then list = list..[[More Items|Next Page,]] end
			menu(p,men.title[4]..[[ (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
		end
	end
end

function sh.select.market(p)
	local list, i, i_cnt, cnt, id, up = [[]], 0, sh.items_cnt(p), 0
	if (pl.menu_id[p] < 2) then
		for id = 1, #sh_item.name do
			up = sh.slot(p, id)
			if (up > 0 and i < 8) then
				i = i + 1
				list = list..sh.item_inv(p, id)
			end
		end
		if (i_cnt > 8) then list = list..[[More Items|Next Page,]] end
		menu(p,men.title[5]..[[ (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
	else
		for id, n in pairs(pl.item[p]) do
			up = sh.up(p, id)
			cnt = cnt + 1
			if (cnt > 8 + ((pl.menu_id[p] - 2) * 7) and cnt < 16 + ((pl.menu_id[p] - 2) * 7)) then
				i = i + 1
				list = list..sh.item_inv(p, id)
			end
		end
		if (i < 1) then
			 sh.select.market_menu(p, -1)
		else
			for m = i, 6 do list = list..[[,]] end
			list = list..[[Previous Items|Back,]]
			if (i_cnt > 15 + ((pl.menu_id[p] - 2) * 7)) then list = list..[[More Items|Next Page,]] end
			menu(p,men.title[5]..[[ (Page: ]]..pl.menu_id[p]..[[)@b,]]..list)
		end
	end
end

function sh.menu_render(p, t, s)
	local b
	if (string.sub(t,1,#men.title[1]) == men.title[1]) then
		if (pl.menu_id[p] < 2) then
			if (s > 0 and s < 9) then
				sh.menu_heroes(p, s)
			elseif (s == 9) then
				sh.select.hero_menu(p, 1)
			end
		else
			b = 8 + ((pl.menu_id[p] - 2) * 7) + s
			if (s > 0 and s < 8) then
				sh.menu_heroes(p,b)
			elseif (s == 8) then
				sh.select.hero_menu(p, -1)
			elseif (s == 9) then
				sh.select.hero_menu(p, 1)
			end
		end
	elseif (string.sub(t,1,#men.title[2]) == men.title[2]) then
		if (pl.menu_id[p] < 2) then
			if (s > 0 and s < 9) then
				sh.menu_reheroes(p, s)
			elseif (s == 9) then
				sh.select.rehero_menu(p, 1)
			end
		else
			b = 8 + ((pl.menu_id[p] - 2) * 7) + s
			if (s > 0 and s < 8) then
				sh.menu_reheroes(p,b)
			elseif (s == 8) then
				sh.select.rehero_menu(p, -1)
			elseif (s == 9) then
				sh.select.rehero_menu(p, 1)
			end
		end
	elseif (string.sub(t,1,#men.title[3]) == men.title[3]) then
		if (pl.menu_id[p] < 2) then
			if (s > 0 and s < 9) then
				sh.menu_items(p, s)
			elseif (s == 9) then
				sh.select.item_menu(p, 1)
			end
		else
			b = 8 + ((pl.menu_id[p] - 2) * 7) + s
			if (s > 0 and s < 8) then
				sh.menu_items(p,b)
			elseif (s == 8) then
				sh.select.item_menu(p, -1)
			elseif (s == 9) then
				sh.select.item_menu(p, 1)
			end
		end
	elseif (string.sub(t,1,#men.title[4]) == men.title[4]) then
		if (pl.menu_id[p] < 2) then
			if (s > 0 and s < 9) then
				sh.menu_inventory(p, s)
			elseif (s == 9) then
				sh.select.inventory_menu(p, 1)
			end
		else
			b = 8 + ((pl.menu_id[p] - 2) * 7) + s
			if (s > 0 and s < 8) then
				sh.menu_inventory(p, b)
			elseif (s == 8) then
				sh.select.inventory_menu(p, -1)
			elseif (s == 9) then
				sh.select.inventory_menu(p, 1)
			end
		end
	elseif (string.sub(t,1,#men.title[5]) == men.title[5]) then
		if (pl.menu_id[p] < 2) then
			if (s > 0 and s < 9) then
				sh.menu_market(p, s)
			elseif (s == 9) then
				sh.select.market_menu(p, 1)
			end
		else
			b = 8 + ((pl.menu_id[p] - 2) * 7) + s
			if (s > 0 and s < 8) then
				sh.menu_market(p, b)
			elseif (s == 8) then
				sh.select.market_menu(p, -1)
			elseif (s == 9) then
				sh.select.market_menu(p, 1)
			end
		end
	elseif (t == men.title[9]) then
		if (s == 1) then sh.select.hero_menu(p)
		elseif (s == 2) then sh.select.rehero_menu(p)
		elseif (s == 3) then sh.select.item_menu(p)
		elseif (s == 4) then sh.select.inventory_menu(p)	
		elseif (s == 5) then sh.select.market_menu(p)
		elseif (s == 6) then sh.say.cmd.console(p) 
		elseif (s == 7) then sh.say.cmd.commands(p)
		elseif (s == 8) then sh.showconfig(p)
		elseif (s == 9) then sh.select.panel(p)
		end
	elseif (t == men.title[10]) then
		if (s == 1) then sh.select.inventory(p)	
		elseif (s == 2) then sh.select.item(p)
		elseif (s == 3) then sh.select.market(p)
		end
	elseif (string.sub(t,1,11) == [[Create User]]) then
		if (s == 1) then
			sh.user_create(p)
			sh.msg2(p, 4, [[You Have Created SH Account!]])
			sh.msg2(p, 7, [[Name: ]]..user.name[p])
			sh.msg2(p, 7, [[Password: ]]..user.password[p])
		end
	elseif (string.sub(t,1,5) == [[Reset]]) then
		if (s == 1) then
			sh.pl_reset(p)
			sh.pl_save(p)
			sh.msg2(p, 2, [[Your Level Has Been Reset!@C]])
			sh.update.hud_lvl(p)
		end
	end
end

function sh.menu_heroes(p,s, sel)
	local up = sh.up(p, s, 1)
	if (pl.stat[p][5] >= hero.level[s][sh.maxup([[level]], s, up)]) then
		if (hero.upgrade[s] >= up) then
			if (pl.stat[p][2] >= hero.point[s][sh.maxup([[point]], s, up)]) then
				if (sh_selecting_msg > 0) then sh.msg2(p, 7, [[You Have Selected ]]..hero.name[s][sh.maxup([[name]], s, up)]) end
				sh.set.power_select(p,s,up)
				pl.hero[p][s] = up
				pl.stat[p][2] = pl.stat[p][2] - hero.point[s][sh.maxup([[point]], s, up)]
				sh.update.hud_lvl(p)
				if not sel then sh.select.hero(p) end
			else
				sh.msg2(p, 2, [[You Don't Have Enough Points! (Need ]]..hero.point[s][sh.maxup([[name]], s, up)] - pl.stat[p][2]..[[ More!)]])
			end
		else
			sh.select.hero(p)
		end
	else
		sh.msg2(p, 2, hero.level[s][sh.maxup([[level]], s, up)]..[[ Level Required!]])
	end
end

function sh.menu_items(p,s)
	if sh_item.hero[s] and hero.name[sh_item.hero[s]] and not pl.hero[p][sh_item.hero[s]] then
		sh.msg2(p, 2, [["]]..hero.name[sh_item.hero[s]][1]..[[" Hero Required!]])
	else
		if (pl.stat[p][5] >= sh_item.level[s]) then
			if (sh.slot(p, s) < sh_item.slot[s]) then
				if (pl.stat[p][3] >= sh_item.credit[s]) then
					sh.msg2(p, 7, [[You've Bought "]]..sh_item.name[s]..[["]])
					pl.item[p][s] = sh.slot(p, s) + 1
					pl.stat[p][3] = pl.stat[p][3] - sh_item.credit[s]
					sh.update.hud_lvl(p)
					sh.pl_save(p)
				else
					sh.msg2(p, 2, [[You Don't Have Enough Credits! (Need ]]..sh_item.credit[s] - pl.stat[p][3]..[[ More!)]])
				end
			else
				sh.msg2(p, 2, [[You Can't Have More Amount Of This Item!]])
			end
		else
			sh.msg2(p, 2, sh_item.level[s]..[[ Level Required!]])
		end
	end
	sh.select.item(p)
end

function sh.menu_reheroes(p,s)
	local i = 0
	for id, n in pairs(pl.hero[p]) do
		i = i + 1 ; if (i == s) then sh.menu_reselect(p,id) ; break end
	end
end

function sh.menu_inventory(p,s)
	local i = 0
	for id, n in pairs(pl.item[p]) do
		i = i + 1 ; if (i == s) then sh.menu_invselect(p,id) ; break end
	end
end

function sh.menu_market(p,s)
	local i = 0
	for id, n in pairs(pl.item[p]) do
		i = i + 1 ; if (i == s) then sh.menu_marketselect(p,id) ; break end
	end
end

function sh.menu_marketselect(p,s)
	local up = pl.item[p][s]
	sh.msg2(p, 7, [[You've Sold "]]..sh_item.name[s]..[["]])
	pl.stat[p][3] = pl.stat[p][3] + sh_item.credit[s]
	if (up > 1) then pl.item[p][s] = up - 1 else pl.item[p][s] = nil end
	sh.select.market(p)
	sh.update.hud_lvl(p)
	sh.pl_save(p)
end

function sh.menu_invselect(p,s)
	if (player(p,[[health]]) > 0) then
		if not sh_item.use_cancel[s] then
			local up = pl.item[p][s]
			sh.msg2(p, 7, [[You've Used "]]..sh_item.name[s]..[["]])
			if (up > 1) then pl.item[p][s] = up - 1 else pl.item[p][s] = nil end
			sh.set.power_use(p, s)
			if sh_item.use_build[s] then
				local id = sh_item.use_build[s]
				sh.build(p, id)
			end
		else		
			msg2(p,sh_item.use_cancel[s])
		end
		sh.select.inventory(p)
	else
		sh.msg2(p, 2, [[Dead Player Can't Use Items!]])
	end
end

function sh.menu_reselect(p,s)
	local up = sh.up(p, s)
	sh.msg2(p, 7, [[You have Re-Selected ]]..hero.name[s][sh.maxup([[name]], s, up)])
	if (up > 1) then pl.hero[p][s] = up - 1 else pl.hero[p][s] = nil end
	pl.stat[p][2] = pl.stat[p][2] + hero.point[s][sh.maxup([[point]], s, up)]
	sh.update.hud_lvl(p)
	sh.select.rehero(p)
end

function sh.hero_button(id, up)
	return hero.name[id][sh.maxup([[name]], id, up)]..[[ (]]..hero.point[id][sh.maxup([[point]], id, up)]..[[) - [Upgrade ]]..(up - 1)..[[/]]..hero.upgrade[id]..[[]|]]..hero.info[id][sh.maxup([[info]], id, up)]..[[,]]
end

function sh.hero_lock(id, up)
	return [[LOCKED|]]..hero.level[id][sh.maxup([[level]], id, up)]..[[ Level To Unlock!,]]
end

function sh.hero_rebutton(id, up)
	return hero.name[id][sh.maxup([[name]], id, up)]..[[ (]]..hero.point[id][sh.maxup([[point]], id, up)]..[[) - [Upgrade ]]..(up)..[[/]]..hero.upgrade[id]..[[]|]]..hero.info[id][sh.maxup([[info]], id, up)]..[[,]]
end

function sh.item_button(p, id)
	return sh_item.name[id]..[[ - ]]..sh_item.info[id]..[[ []]..sh.slot(p, id)..[[/]]..sh_item.slot[id]..[[] | ]]..sh_item.credit[id]..[[ Credits,]]
end

function sh.item_inv(p, id)
	return sh_item.name[id]..[[ []]..sh.slot(p, id)..[[/]]..sh_item.slot[id]..[[]|]]..sh_item.info[id]..[[ Credits,]]
end

function sh.item_lock(id)
	return [[LOCKED|]]..sh_item.level[id]..[[ Level To Unlock!,]]
end

function sh.slot(p, id)
	local slot = 0
	if pl.item[p][id] then slot = pl.item[p][id] end
	return slot
end

function sh.heroes_cnt(p)
	local cnt = 0
	for id, n in pairs(pl.hero[p]) do cnt = cnt + 1 end
	return cnt
end

function sh.items_cnt(p)
	local cnt = 0
	for id, n in pairs(pl.item[p]) do cnt = cnt + 1 end
	return cnt
end

function sh.select.panel(p)
	if sh.member.name[player(p,[[usgn]])] then
		
	else
		sh.msg2(p,2,[[This Feature Members Only!]])
	end
end