-----------------------------------
-- Say Commands Initialization   --
-----------------------------------

function sh.say.cmd.help(p)
	sh.select.main(p)
end

function sh.say.cmd.commands(p)
	local i, cmd, n = 0	
	sh.msg2(p,1,[[===== Say Commands =====]])
	for cmd, n in pairs(sh.say.cmd) do		
		if (sh.say.info[cmd]) then
			i = i + 1 ; sh.msg2(p,4,i..[[. !]]..cmd..sh.say.info[cmd][1])
		end
	end
end

function sh.say.cmd.console(p)
	local i, cmd, n = 0
	sh.msg2(p,1,[[===== Console Commands =====]])
	for cmd, n in pairs(sh.con.cmd) do		
		if (sh.con.info[cmd]) then
			i = i + 1 ; sh.msg2(p,4,i..[[. sh_]]..cmd..sh.con.info[cmd][1])
		end
	end
end

function sh.say.cmd.heroes(p)
	sh.select.hero_menu(p)
end

function sh.say.cmd.reheroes(p)
	sh.select.rehero_menu(p)
end

function sh.say.cmd.myheroes(p)
	local i = 0
	sh.msg2(p,1,[[===== Your Heroes =====]])
	for id, n in pairs(pl.hero[p]) do
		i = i + 1 ; up = sh.up(p, id)
		sh.msg2(p,4,i..[[. ]]..sh.hero_msg(id, up))
	end
end

function sh.say.cmd.mystats(p)
	sh.msg2(p,1,[[===== Your Stats =====]])
	sh.msg2(p,4,[[Level: ]]..pl.stat[p][5])
	sh.msg2(p,4,[[Experience: (]]..pl.stat[p][1]..[[/]]..pl.stat[p][4]..[[)]])
	sh.msg2(p,4,[[Points Left: ]]..pl.stat[p][2])
	sh.msg2(p,4,[[Credits: ]]..pl.stat[p][3])
	sh.msg2(p,4,[[Heroes Count: ]]..sh.heroes_cnt(p))
end

function sh.say.cmd.myitems(p)
	local i = 0
	sh.msg2(p,1,[[===== Your Items =====]])
	for id, n in pairs(pl.item[p]) do
		i = i + 1
		sh.msg2(p,4,i..[[. ]]..sh_item.name[id]..[[ [Slot ]]..sh_item.slot[id]..[[/]]..n..[[]   -   ]]..sh_item.info[id])
	end
end

function sh.say.cmd.heroeslist(p)
	sh.msg2(p,1,[[===== Heroes List =====]])
	for id, n in pairs(hero.name) do
		sh.msg2(p,4,id..[[. ]]..n[1]..[[  -  ]]..hero.info[id][1])
	end
end

function sh.say.cmd.roundlist(p)
	local  txt
	sh.msg2(p,1,[[===== Weapon Rounds List =====]])
	for k, l in pairs(round) do
		txt = [[]]
		for m, n in pairs(l) do
			if (m > 1) then txt = txt..[[ & ]] end
			txt = txt..itemtype(n,[[name]])
		end
		sh.msg2(p,4,k..[[. ]]..txt)
	end
end

function sh.say.cmd.playerslist(p)
	sh.msg2(p,1,[[===== Players List =====]])
	for n, id in pairs(player(0,[[table]])) do
		sh.msg2(p, 4, n..[[. ]]..player(id,[[name]])..[[  |  Level: ]]..pl.stat[id][5]..[[  |  Experience: (]]..pl.stat[id][1]..[[/]]..pl.stat[id][4]..[[)]]..[[  |  Points: ]]..pl.stat[id][2]..[[  |  Credits: ]]..pl.stat[id][3])
	end
end

function sh.say.cmd.whohas(p, t)
	local shero, i, m, n, k, l = string.lower(t[1]), 0
	sh.msg2(p,1,[[===== Who Has "]]..t[1]..[[" ? =====]])
	for m, n in pairs(player(0,[[table]])) do
		for k, l in pairs(pl.hero[n]) do
			i = i + 1
			if string.find(string.lower(hero.name[k][1]), shero) then
				sh.msg2(p, 4, i..[[. ]]..player(n,[[name]])..[[  |  ]]..hero.name[k][1])
			end
		end
	end
end

function sh.say.cmd.clearheroes(p)
	pl.hero[p] = {}
	pl.stat[p][2] = sh_pt_start + (sh_pt_lvl * (pl.stat[p][5] - 1))
	sh.update.hud_all(p)
	sh.msg2(p, 1, [[Your All Heroes Were Removed!@C]])
end

function sh.say.cmd.whatstats(p, t)
	local p_ = tonumber(t[1])
	if (p ~= p_) then
		if (p_ and player(p_, [[exists]])) then
			sh.msg(7,player(p,[[name]])..[[ Watching ]]..player(p_,[[name]])..[[ Stats!]])
			sh.msg2(p,1,[[===== ]]..player(p_,[[name]])..[[ Stats =====]])
			sh.msg2(p,4,[[Level: ]]..pl.stat[p_][5])
			sh.msg2(p,4,[[Experience: (]]..pl.stat[p_][1]..[[/]]..pl.stat[p_][4]..[[)]])
			sh.msg2(p,4,[[Points Left: ]]..pl.stat[p_][2])
			sh.msg2(p,4,[[Credits: ]]..pl.stat[p_][3])
			sh.msg2(p,4,[[Heroes Count: ]]..sh.heroes_cnt(p_))
		else
			sh.msg2(p, 2, [[Player Doesn't Exist!]])
		end
	else
		sh.msg2(p, 2, [[You Can't Watch Your Own Stats!]])
	end
end

function sh.say.cmd.whatheroes(p, t)
	local p_, i = tonumber(t[1]), 0
	if (p ~= p_) then
		if (p_ and player(p_, [[exists]])) then
			sh.msg(7,player(p,[[name]])..[[ Watching ]]..player(p_,[[name]])..[[ Heroes!]])
			sh.msg2(p,1,[[===== ]]..player(p_,[[name]])..[[ Heroes =====]])
			for id, n in pairs(pl.hero[p_]) do
				i = i + 1 ; up = sh.up(p_, id)
				sh.msg2(p,4,i..[[. ]]..sh.hero_msg(id, up))
			end	
		else
			sh.msg2(p, 2, [[Player Doesn't Exist!]])
		end
	else
		sh.msg2(p, 2, [[You Can't Watch Your Own Heroes!]])
	end
end

function sh.say.cmd.register(p, t)
	t[1], t[2] = string.lower(t[1]), string.lower(t[2])
	if (sh.user_exist(t[1])) then
		sh.msg2(p, 2, [[User "]]..t[1]..[[" Already Exist!]])
	else
		user.name[p] = t[1]
		user.password[p] = t[2]
		menu(p, [[Create User - Are You Sure?,Yes - Register "]]..t[1]..[[", No]])
	end
end

function sh.say.cmd.login(p, t)
	t[1], t[2] = string.lower(t[1]), string.lower(t[2])
	if (sh_save_user > 0) then
		if (sh.user_exist(t[1])) then
			if (sh.user_password(t[1],t[2])) then
				if not user.login[p] then
					local loged =  false
					for n, id in pairs(player(0,[[table]])) do
						if (user.name[id] == t[1] and user.login[id]) then loged = true end
					end
					if not loged then
						pl.hero[p] = {}
						pl.item[p] = {}
						user.login[p] = true
						sh.user_load(p, t[1])
						sh.update.hud_all(p)
						sh.remove.pl_images(p)
					else
						sh.msg2(p, 2, [[This User Is Already Loged By Someone Else!]])
					end
				else
					sh.msg2(p, 2, [[You're Already Loged In!]])
				end
			else
				sh.msg2(p, 2, [[Wrong Password!]])
			end
		else
			sh.msg2(p, 2, [[User "]]..t[1]..[[" Doesn't Exist!]])
		end
	else
		sh.msg2(p, 2, [[This Feature Is Disabled!]])
	end
end

function sh.say.cmd.logout(p, t)
	if (user.login[p]) then
		if (sh_save_heroes > 0) then sh.pl_save_heroes(p) end
		if (sh_save_items > 0) then sh.pl_save_items(p) end
		sh.pl_set(p)
		sh.load_pl_usgn(p)
		sh.update.hud_all(p)
		sh.remove.pl_images(p)
	else
		sh.msg2(p, 2, [[You Are Not Loged In!]])
	end
end

function sh.say.cmd.helpon(p)
	sh.help_show(p)
end

function sh.say.cmd.helpoff(p)
	sh.help_hide(p)
end

function sh.say.cmd.shop(p)
	sh.select.item_menu(p)
end

function sh.say.cmd.members(p)
	local i, state, on = 0, {[[Online]], [[Offline]]}
	sh.msg2(p,1,[[===== Server Members =====]])
	for id, n in pairs(sh.member.name) do
		i = i + 1 ; on = 2
		for k, p_ in pairs(player(0,[[table]])) do
			if (player(p_,[[usgn]]) == id) then on = 1 end
		end
		sh.msg2(p,on,i..[[. ]]..n..[[ (#]]..id..[[) - ]]..state[on])
	end
end

function sh.say.cmd.inventory(p)
	sh.select.inventory_menu(p)
end

function sh.say.cmd.market(p)
	sh.select.market_menu(p)
end

function sh.say.cmd.givecr(p, t)
	local p_, cr = tonumber(t[1]), tonumber(t[2])
	if (p_ and cr) then
		if (p ~= p_) then
			if (cr > 0 and c ~= nil) then
				if (player(p_,[[exists]])) then
					if (pl.stat[p][3] >= cr) then
						pl.stat[p][3] = pl.stat[p][3] - cr
						pl.stat[p_][3] = pl.stat[p_][3] + cr
						sh.msg(1,player(p,[[name]])..[[ Gave His Own ]]..cr..[[ Credits To ]]..player(p_,[[name]])..[[!]])
						sh.msg2(p_,1,player(p,[[name]])..[[ Gave You ]]..cr..[[ Credits!@C]])
						sh.update.hud_lvl(p_) ; sh.update.hud_lvl(p)
						sh.pl_save(p) ; sh.pl_save(p_)
					else
						sh.msg2(p,2,[[You Dont Have ]]..cr..[[ Credits!]])
					end
				else
					sh.msg2(p,2,[[Player Does Not Exist!]])
				end
			else
				sh.msg2(p,2,[[You Can't Steal Credits!]])
			end
		else
			sh.msg2(p,2,[[You Can't Give Credits to Yourself!]])
		end
	else
		sh.msg2(p,2,[[Command Does not Have Right Parameters!]])
	end
end

function sh.say.cmd.reset(p)
	if (sh_lvl_max <= pl.stat[p][5]) then
		menu(p,[[Reset - Are you Sure, Yes|Accept, No|Decline]])
	else
		sh.msg2(p,2,[[You Need To Be On Max Level For This Command!]])
	end
end

function sh.say.cmd.kick(p, t)
	if (sh.member.name[player(p,[[usgn]])]) then
		parse([[kick ]]..t[1])
	else
		sh.msg2(p,2,[[This Command Only For Members!]])
	end
end